/* DateTime.c generated by valac 0.56.18, the Vala compiler
 * generated from DateTime.vala, do not modify */

/*
 * Copyright 2012-2017 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite-7.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>
#include <glib-object.h>
#include <gio/gio.h>

#define GRANITE_GETTEXT_PACKAGE "granite-7"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GRANITE_PORTAL_TYPE_SETTINGS (granite_portal_settings_get_type ())
#define GRANITE_PORTAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_PORTAL_TYPE_SETTINGS, GranitePortalSettings))
#define GRANITE_PORTAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_PORTAL_TYPE_SETTINGS))
#define GRANITE_PORTAL_SETTINGS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_PORTAL_TYPE_SETTINGS, GranitePortalSettingsIface))

typedef struct _GranitePortalSettings GranitePortalSettings;
typedef struct _GranitePortalSettingsIface GranitePortalSettingsIface;

#define GRANITE_PORTAL_TYPE_SETTINGS_PROXY (granite_portal_settings_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GranitePortalSettingsIface {
	GTypeInterface parent_iface;
	GHashTable* (*read_all) (GranitePortalSettings* self, gchar** namespaces, gint namespaces_length1, GError** error);
	GVariant* (*read) (GranitePortalSettings* self, const gchar* namespace, const gchar* key, GError** error);
};

 G_GNUC_INTERNAL gboolean granite_date_time_is_clock_format_12h (void);
VALA_EXTERN GType granite_portal_settings_proxy_get_type (void) G_GNUC_CONST ;
 G_GNUC_INTERNAL guint granite_portal_settings_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
 G_GNUC_INTERNAL GType granite_portal_settings_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
 G_GNUC_INTERNAL GranitePortalSettings* granite_portal_settings_get (GError** error);
 G_GNUC_INTERNAL GVariant* granite_portal_settings_read (GranitePortalSettings* self,
                                        const gchar* namespace,
                                        const gchar* key,
                                        GError** error);

/**
     * Gets a default translated time format.
     * The function constructs a new string interpreting the //is_12h// and //with_second// parameters
     * so that it can be used with formatting functions like {@link GLib.DateTime.format}.
     *
     * The returned string is formatted and translated. This function is mostly used to display
     * the time in various user interfaces like the time displayed in the top panel.
     *
     * @param is_12h if the returned string should be formatted in 12h format
     * @param with_second if the returned string should include seconds
     *
     * @return the formatted and located time string.
     */
gchar*
granite_date_time_get_default_time_format (gboolean is_12h,
                                           gboolean with_second)
{
	gchar* result;
#line 25 "../lib/DateTime.vala"
	if (is_12h == TRUE) {
#line 26 "../lib/DateTime.vala"
		if (with_second == TRUE) {
#line 87 "DateTime.c"
			gchar* _tmp0_;
#line 28 "../lib/DateTime.vala"
			_tmp0_ = g_strdup (_ ("%-l:%M:%S %p"));
#line 28 "../lib/DateTime.vala"
			result = _tmp0_;
#line 28 "../lib/DateTime.vala"
			return result;
#line 95 "DateTime.c"
		} else {
			gchar* _tmp1_;
#line 31 "../lib/DateTime.vala"
			_tmp1_ = g_strdup (_ ("%-l:%M %p"));
#line 31 "../lib/DateTime.vala"
			result = _tmp1_;
#line 31 "../lib/DateTime.vala"
			return result;
#line 104 "DateTime.c"
		}
	} else {
#line 34 "../lib/DateTime.vala"
		if (with_second == TRUE) {
#line 109 "DateTime.c"
			gchar* _tmp2_;
#line 36 "../lib/DateTime.vala"
			_tmp2_ = g_strdup (_ ("%H:%M:%S"));
#line 36 "../lib/DateTime.vala"
			result = _tmp2_;
#line 36 "../lib/DateTime.vala"
			return result;
#line 117 "DateTime.c"
		} else {
			gchar* _tmp3_;
#line 39 "../lib/DateTime.vala"
			_tmp3_ = g_strdup (_ ("%H:%M"));
#line 39 "../lib/DateTime.vala"
			result = _tmp3_;
#line 39 "../lib/DateTime.vala"
			return result;
#line 126 "DateTime.c"
		}
	}
}

/**
     * Compares a {@link GLib.DateTime} to {@link GLib.DateTime.now_local} and returns a location, relative date and
     * time string. Results appear as natural-language strings like "Now", "5m ago", "Yesterday"
     *
     * @param date_time a {@link GLib.DateTime} to compare against {@link GLib.DateTime.now_local}
     *
     * @return a localized, relative date and time string
     */
gchar*
granite_date_time_get_relative_datetime (GDateTime* date_time)
{
	GDateTime* now = NULL;
	GDateTime* _tmp1_;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gchar* result;
#line 52 "../lib/DateTime.vala"
	g_return_val_if_fail (date_time != NULL, NULL);
#line 53 "../lib/DateTime.vala"
	if (g_date_time_to_unix (date_time) == ((gint64) 0)) {
#line 152 "DateTime.c"
		gchar* _tmp0_;
#line 54 "../lib/DateTime.vala"
		_tmp0_ = g_strdup (_ ("Never"));
#line 54 "../lib/DateTime.vala"
		result = _tmp0_;
#line 54 "../lib/DateTime.vala"
		return result;
#line 160 "DateTime.c"
	}
#line 57 "../lib/DateTime.vala"
	_tmp1_ = g_date_time_new_now_local ();
#line 57 "../lib/DateTime.vala"
	now = _tmp1_;
#line 58 "../lib/DateTime.vala"
	_tmp2_ = now;
#line 58 "../lib/DateTime.vala"
	diff = g_date_time_difference (_tmp2_, date_time);
#line 60 "../lib/DateTime.vala"
	_tmp3_ = now;
#line 60 "../lib/DateTime.vala"
	if (granite_date_time_is_same_day (date_time, _tmp3_)) {
#line 174 "DateTime.c"
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 61 "../lib/DateTime.vala"
		if (diff > ((GTimeSpan) 0)) {
#line 62 "../lib/DateTime.vala"
			if (diff < G_TIME_SPAN_MINUTE) {
#line 183 "DateTime.c"
				gchar* _tmp4_;
#line 63 "../lib/DateTime.vala"
				_tmp4_ = g_strdup (_ ("Now"));
#line 63 "../lib/DateTime.vala"
				result = _tmp4_;
#line 63 "../lib/DateTime.vala"
				_g_date_time_unref0 (now);
#line 63 "../lib/DateTime.vala"
				return result;
#line 193 "DateTime.c"
			} else {
#line 64 "../lib/DateTime.vala"
				if (diff < G_TIME_SPAN_HOUR) {
#line 197 "DateTime.c"
					GTimeSpan minutes = 0LL;
					gchar* _tmp5_;
#line 65 "../lib/DateTime.vala"
					minutes = diff / G_TIME_SPAN_MINUTE;
#line 66 "../lib/DateTime.vala"
					_tmp5_ = g_strdup_printf (g_dngettext (GRANITE_GETTEXT_PACKAGE, "%dm ago", "%dm ago", (gulong) minutes), (gint) minutes);
#line 66 "../lib/DateTime.vala"
					result = _tmp5_;
#line 66 "../lib/DateTime.vala"
					_g_date_time_unref0 (now);
#line 66 "../lib/DateTime.vala"
					return result;
#line 210 "DateTime.c"
				} else {
#line 67 "../lib/DateTime.vala"
					if (diff < (12 * G_TIME_SPAN_HOUR)) {
#line 214 "DateTime.c"
						gint rounded = 0;
						gchar* _tmp6_;
#line 68 "../lib/DateTime.vala"
						rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
#line 69 "../lib/DateTime.vala"
						_tmp6_ = g_strdup_printf (g_dngettext (GRANITE_GETTEXT_PACKAGE, "%dh ago", "%dh ago", (gulong) rounded), rounded);
#line 69 "../lib/DateTime.vala"
						result = _tmp6_;
#line 69 "../lib/DateTime.vala"
						_g_date_time_unref0 (now);
#line 69 "../lib/DateTime.vala"
						return result;
#line 227 "DateTime.c"
					}
				}
			}
		} else {
#line 72 "../lib/DateTime.vala"
			diff = -1 * diff;
#line 73 "../lib/DateTime.vala"
			if (diff < G_TIME_SPAN_HOUR) {
#line 236 "DateTime.c"
				GTimeSpan minutes = 0LL;
				gchar* _tmp7_;
#line 74 "../lib/DateTime.vala"
				minutes = diff / G_TIME_SPAN_MINUTE;
#line 75 "../lib/DateTime.vala"
				_tmp7_ = g_strdup_printf (g_dngettext (GRANITE_GETTEXT_PACKAGE, "in %dm", "in %dm", (gulong) minutes), (gint) minutes);
#line 75 "../lib/DateTime.vala"
				result = _tmp7_;
#line 75 "../lib/DateTime.vala"
				_g_date_time_unref0 (now);
#line 75 "../lib/DateTime.vala"
				return result;
#line 249 "DateTime.c"
			} else {
#line 76 "../lib/DateTime.vala"
				if (diff < (12 * G_TIME_SPAN_HOUR)) {
#line 253 "DateTime.c"
					gint rounded = 0;
					gchar* _tmp8_;
#line 77 "../lib/DateTime.vala"
					rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
#line 78 "../lib/DateTime.vala"
					_tmp8_ = g_strdup_printf (g_dngettext (GRANITE_GETTEXT_PACKAGE, "in %dh", "in %dh", (gulong) rounded), rounded);
#line 78 "../lib/DateTime.vala"
					result = _tmp8_;
#line 78 "../lib/DateTime.vala"
					_g_date_time_unref0 (now);
#line 78 "../lib/DateTime.vala"
					return result;
#line 266 "DateTime.c"
				}
			}
		}
#line 82 "../lib/DateTime.vala"
		_tmp9_ = granite_date_time_get_default_time_format (granite_date_time_is_clock_format_12h (), FALSE);
#line 82 "../lib/DateTime.vala"
		_tmp10_ = _tmp9_;
#line 82 "../lib/DateTime.vala"
		_tmp11_ = g_date_time_format (date_time, _tmp10_);
#line 82 "../lib/DateTime.vala"
		_tmp12_ = _tmp11_;
#line 82 "../lib/DateTime.vala"
		_g_free0 (_tmp10_);
#line 82 "../lib/DateTime.vala"
		result = _tmp12_;
#line 82 "../lib/DateTime.vala"
		_g_date_time_unref0 (now);
#line 82 "../lib/DateTime.vala"
		return result;
#line 286 "DateTime.c"
	} else {
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		GDateTime* _tmp15_;
		gboolean _tmp16_;
#line 83 "../lib/DateTime.vala"
		_tmp13_ = g_date_time_add_days (date_time, 1);
#line 83 "../lib/DateTime.vala"
		_tmp14_ = _tmp13_;
#line 83 "../lib/DateTime.vala"
		_tmp15_ = now;
#line 83 "../lib/DateTime.vala"
		_tmp16_ = granite_date_time_is_same_day (_tmp14_, _tmp15_);
#line 83 "../lib/DateTime.vala"
		_g_date_time_unref0 (_tmp14_);
#line 83 "../lib/DateTime.vala"
		if (_tmp16_) {
#line 304 "DateTime.c"
			gchar* _tmp17_;
#line 84 "../lib/DateTime.vala"
			_tmp17_ = g_strdup (_ ("Yesterday"));
#line 84 "../lib/DateTime.vala"
			result = _tmp17_;
#line 84 "../lib/DateTime.vala"
			_g_date_time_unref0 (now);
#line 84 "../lib/DateTime.vala"
			return result;
#line 314 "DateTime.c"
		} else {
			GDateTime* _tmp18_;
			GDateTime* _tmp19_;
			GDateTime* _tmp20_;
			gboolean _tmp21_;
#line 85 "../lib/DateTime.vala"
			_tmp18_ = g_date_time_add_days (date_time, -1);
#line 85 "../lib/DateTime.vala"
			_tmp19_ = _tmp18_;
#line 85 "../lib/DateTime.vala"
			_tmp20_ = now;
#line 85 "../lib/DateTime.vala"
			_tmp21_ = granite_date_time_is_same_day (_tmp19_, _tmp20_);
#line 85 "../lib/DateTime.vala"
			_g_date_time_unref0 (_tmp19_);
#line 85 "../lib/DateTime.vala"
			if (_tmp21_) {
#line 332 "DateTime.c"
				gchar* _tmp22_;
#line 86 "../lib/DateTime.vala"
				_tmp22_ = g_strdup (_ ("Tomorrow"));
#line 86 "../lib/DateTime.vala"
				result = _tmp22_;
#line 86 "../lib/DateTime.vala"
				_g_date_time_unref0 (now);
#line 86 "../lib/DateTime.vala"
				return result;
#line 342 "DateTime.c"
			} else {
				gboolean _tmp23_ = FALSE;
#line 87 "../lib/DateTime.vala"
				if (diff < (6 * G_TIME_SPAN_DAY)) {
#line 87 "../lib/DateTime.vala"
					_tmp23_ = diff > (-6 * G_TIME_SPAN_DAY);
#line 349 "DateTime.c"
				} else {
#line 87 "../lib/DateTime.vala"
					_tmp23_ = FALSE;
#line 353 "DateTime.c"
				}
#line 87 "../lib/DateTime.vala"
				if (_tmp23_) {
#line 357 "DateTime.c"
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
#line 88 "../lib/DateTime.vala"
					_tmp24_ = granite_date_time_get_default_date_format (TRUE, FALSE, FALSE);
#line 88 "../lib/DateTime.vala"
					_tmp25_ = _tmp24_;
#line 88 "../lib/DateTime.vala"
					_tmp26_ = g_date_time_format (date_time, _tmp25_);
#line 88 "../lib/DateTime.vala"
					_tmp27_ = _tmp26_;
#line 88 "../lib/DateTime.vala"
					_g_free0 (_tmp25_);
#line 88 "../lib/DateTime.vala"
					result = _tmp27_;
#line 88 "../lib/DateTime.vala"
					_g_date_time_unref0 (now);
#line 88 "../lib/DateTime.vala"
					return result;
#line 378 "DateTime.c"
				} else {
					GDateTime* _tmp28_;
#line 89 "../lib/DateTime.vala"
					_tmp28_ = now;
#line 89 "../lib/DateTime.vala"
					if (g_date_time_get_year (date_time) == g_date_time_get_year (_tmp28_)) {
#line 385 "DateTime.c"
						gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
#line 90 "../lib/DateTime.vala"
						_tmp29_ = granite_date_time_get_default_date_format (FALSE, TRUE, FALSE);
#line 90 "../lib/DateTime.vala"
						_tmp30_ = _tmp29_;
#line 90 "../lib/DateTime.vala"
						_tmp31_ = g_date_time_format (date_time, _tmp30_);
#line 90 "../lib/DateTime.vala"
						_tmp32_ = _tmp31_;
#line 90 "../lib/DateTime.vala"
						_g_free0 (_tmp30_);
#line 90 "../lib/DateTime.vala"
						result = _tmp32_;
#line 90 "../lib/DateTime.vala"
						_g_date_time_unref0 (now);
#line 90 "../lib/DateTime.vala"
						return result;
#line 406 "DateTime.c"
					} else {
						gchar* _tmp33_;
#line 92 "../lib/DateTime.vala"
						_tmp33_ = g_date_time_format (date_time, "%x");
#line 92 "../lib/DateTime.vala"
						result = _tmp33_;
#line 92 "../lib/DateTime.vala"
						_g_date_time_unref0 (now);
#line 92 "../lib/DateTime.vala"
						return result;
#line 417 "DateTime.c"
					}
				}
			}
		}
	}
}

/**
     * Gets the //clock-format// key from //org.gnome.desktop.interface// schema
     * and determines if the clock format is 12h based
     *
     * @return true if the clock format is 12h based, false otherwise.
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 447 "DateTime.c"
}

 G_GNUC_INTERNAL gboolean
granite_date_time_is_clock_format_12h (void)
{
	gchar* format = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp15_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 103 "../lib/DateTime.vala"
	format = NULL;
#line 460 "DateTime.c"
	{
		GranitePortalSettings* portal = NULL;
		GranitePortalSettings* _tmp0_;
		GVariant* _tmp1_ = NULL;
		GranitePortalSettings* _tmp2_;
		GVariant* _tmp3_;
		GVariant* variant = NULL;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 105 "../lib/DateTime.vala"
		_tmp0_ = granite_portal_settings_get (&_inner_error0_);
#line 105 "../lib/DateTime.vala"
		portal = _tmp0_;
#line 105 "../lib/DateTime.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 478 "DateTime.c"
			goto __catch0_g_error;
		}
#line 106 "../lib/DateTime.vala"
		_tmp2_ = portal;
#line 106 "../lib/DateTime.vala"
		_tmp3_ = granite_portal_settings_read (_tmp2_, "org.gnome.desktop.interface", "clock-format", &_inner_error0_);
#line 106 "../lib/DateTime.vala"
		_tmp1_ = _tmp3_;
#line 106 "../lib/DateTime.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../lib/DateTime.vala"
			_g_object_unref0 (portal);
#line 491 "DateTime.c"
			goto __catch0_g_error;
		}
#line 106 "../lib/DateTime.vala"
		_tmp4_ = g_variant_get_variant (_tmp1_);
#line 106 "../lib/DateTime.vala"
		variant = _tmp4_;
#line 107 "../lib/DateTime.vala"
		_tmp5_ = variant;
#line 107 "../lib/DateTime.vala"
		_tmp6_ = g_variant_get_string (_tmp5_, NULL);
#line 107 "../lib/DateTime.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 107 "../lib/DateTime.vala"
		_g_free0 (format);
#line 107 "../lib/DateTime.vala"
		format = _tmp7_;
#line 104 "../lib/DateTime.vala"
		_g_variant_unref0 (variant);
#line 104 "../lib/DateTime.vala"
		_g_variant_unref0 (_tmp1_);
#line 104 "../lib/DateTime.vala"
		_g_object_unref0 (portal);
#line 514 "DateTime.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 104 "../lib/DateTime.vala"
		e = _inner_error0_;
#line 104 "../lib/DateTime.vala"
		_inner_error0_ = NULL;
#line 109 "../lib/DateTime.vala"
		_tmp8_ = e;
#line 109 "../lib/DateTime.vala"
		_tmp9_ = _tmp8_->message;
#line 109 "../lib/DateTime.vala"
		g_debug ("DateTime.vala:109: cannot use portal, using GSettings: %s", _tmp9_);
#line 104 "../lib/DateTime.vala"
		_g_error_free0 (e);
#line 534 "DateTime.c"
	}
	__finally0:
#line 104 "../lib/DateTime.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 539 "DateTime.c"
		gboolean _tmp10_ = FALSE;
#line 104 "../lib/DateTime.vala"
		_g_free0 (format);
#line 104 "../lib/DateTime.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../lib/DateTime.vala"
		g_clear_error (&_inner_error0_);
#line 104 "../lib/DateTime.vala"
		return _tmp10_;
#line 549 "DateTime.c"
	}
#line 112 "../lib/DateTime.vala"
	_tmp11_ = format;
#line 112 "../lib/DateTime.vala"
	if (_tmp11_ == NULL) {
#line 555 "DateTime.c"
		GSettings* h24_settings = NULL;
		GSettings* _tmp12_;
		GSettings* _tmp13_;
		gchar* _tmp14_;
#line 113 "../lib/DateTime.vala"
		_tmp12_ = g_settings_new ("org.gnome.desktop.interface");
#line 113 "../lib/DateTime.vala"
		h24_settings = _tmp12_;
#line 114 "../lib/DateTime.vala"
		_tmp13_ = h24_settings;
#line 114 "../lib/DateTime.vala"
		_tmp14_ = g_settings_get_string (_tmp13_, "clock-format");
#line 114 "../lib/DateTime.vala"
		_g_free0 (format);
#line 114 "../lib/DateTime.vala"
		format = _tmp14_;
#line 112 "../lib/DateTime.vala"
		_g_object_unref0 (h24_settings);
#line 574 "DateTime.c"
	}
#line 117 "../lib/DateTime.vala"
	_tmp15_ = format;
#line 117 "../lib/DateTime.vala"
	result = string_contains (_tmp15_, "12h");
#line 117 "../lib/DateTime.vala"
	_g_free0 (format);
#line 117 "../lib/DateTime.vala"
	return result;
#line 584 "DateTime.c"
}

/**
     * Compare two {@link GLib.DateTime} and return true if they occur on the same day of the same year
     *
     * @param day1 a {@link GLib.DateTime} to compare against day2
     * @param day2 a {@link GLib.DateTime} to compare against day1
     *
     * @return true if day1 and day2 occur on the same day of the same year. False otherwise
     */
gboolean
granite_date_time_is_same_day (GDateTime* day1,
                               GDateTime* day2)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 128 "../lib/DateTime.vala"
	g_return_val_if_fail (day1 != NULL, FALSE);
#line 128 "../lib/DateTime.vala"
	g_return_val_if_fail (day2 != NULL, FALSE);
#line 129 "../lib/DateTime.vala"
	if (g_date_time_get_day_of_year (day1) == g_date_time_get_day_of_year (day2)) {
#line 129 "../lib/DateTime.vala"
		_tmp0_ = g_date_time_get_year (day1) == g_date_time_get_year (day2);
#line 609 "DateTime.c"
	} else {
#line 129 "../lib/DateTime.vala"
		_tmp0_ = FALSE;
#line 613 "DateTime.c"
	}
#line 129 "../lib/DateTime.vala"
	result = _tmp0_;
#line 129 "../lib/DateTime.vala"
	return result;
#line 619 "DateTime.c"
}

/**
     * Gets the default translated date format.
     * The function constructs a new string interpreting the //with_weekday//, //with_day// and //with_year// parameters
     * so that it can be used with formatting functions like {@link GLib.DateTime.format}.
     *
     * As the {@link Granite.DateTime.get_default_time_format}, the returned string is formatted, translated and is also mostly used to display
     * the date in various user interfaces like the date displayed in the top panel.
     *
     * @param with_weekday if the returned string should contain the abbreviated weekday name
     * @param with_day if the returned string should contain contain the day of the month as a decimal number (range 1 to 31)
     * @param with_year if the returned string should contain the year as a decimal number including the century
     *
     * @return returns the formatted and located date string. If for some reason, the function could not determine the format to use,
     *         an empty string will be returned.
     */
gchar*
granite_date_time_get_default_date_format (gboolean with_weekday,
                                           gboolean with_day,
                                           gboolean with_year)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp24_;
	gchar* result;
#line 148 "../lib/DateTime.vala"
	if (with_weekday == TRUE) {
#line 148 "../lib/DateTime.vala"
		_tmp1_ = with_day == TRUE;
#line 650 "DateTime.c"
	} else {
#line 148 "../lib/DateTime.vala"
		_tmp1_ = FALSE;
#line 654 "DateTime.c"
	}
#line 148 "../lib/DateTime.vala"
	if (_tmp1_) {
#line 148 "../lib/DateTime.vala"
		_tmp0_ = with_year == TRUE;
#line 660 "DateTime.c"
	} else {
#line 148 "../lib/DateTime.vala"
		_tmp0_ = FALSE;
#line 664 "DateTime.c"
	}
#line 148 "../lib/DateTime.vala"
	if (_tmp0_) {
#line 668 "DateTime.c"
		gchar* _tmp2_;
#line 150 "../lib/DateTime.vala"
		_tmp2_ = g_strdup (_ ("%a, %b %e, %Y"));
#line 150 "../lib/DateTime.vala"
		result = _tmp2_;
#line 150 "../lib/DateTime.vala"
		return result;
#line 676 "DateTime.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
#line 151 "../lib/DateTime.vala"
		if (with_weekday == FALSE) {
#line 151 "../lib/DateTime.vala"
			_tmp4_ = with_day == TRUE;
#line 684 "DateTime.c"
		} else {
#line 151 "../lib/DateTime.vala"
			_tmp4_ = FALSE;
#line 688 "DateTime.c"
		}
#line 151 "../lib/DateTime.vala"
		if (_tmp4_) {
#line 151 "../lib/DateTime.vala"
			_tmp3_ = with_year == TRUE;
#line 694 "DateTime.c"
		} else {
#line 151 "../lib/DateTime.vala"
			_tmp3_ = FALSE;
#line 698 "DateTime.c"
		}
#line 151 "../lib/DateTime.vala"
		if (_tmp3_) {
#line 702 "DateTime.c"
			gchar* _tmp5_;
#line 153 "../lib/DateTime.vala"
			_tmp5_ = g_strdup (_ ("%b %e %Y"));
#line 153 "../lib/DateTime.vala"
			result = _tmp5_;
#line 153 "../lib/DateTime.vala"
			return result;
#line 710 "DateTime.c"
		} else {
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
#line 154 "../lib/DateTime.vala"
			if (with_weekday == FALSE) {
#line 154 "../lib/DateTime.vala"
				_tmp7_ = with_day == FALSE;
#line 718 "DateTime.c"
			} else {
#line 154 "../lib/DateTime.vala"
				_tmp7_ = FALSE;
#line 722 "DateTime.c"
			}
#line 154 "../lib/DateTime.vala"
			if (_tmp7_) {
#line 154 "../lib/DateTime.vala"
				_tmp6_ = with_year == TRUE;
#line 728 "DateTime.c"
			} else {
#line 154 "../lib/DateTime.vala"
				_tmp6_ = FALSE;
#line 732 "DateTime.c"
			}
#line 154 "../lib/DateTime.vala"
			if (_tmp6_) {
#line 736 "DateTime.c"
				gchar* _tmp8_;
#line 156 "../lib/DateTime.vala"
				_tmp8_ = g_strdup (_ ("%Y"));
#line 156 "../lib/DateTime.vala"
				result = _tmp8_;
#line 156 "../lib/DateTime.vala"
				return result;
#line 744 "DateTime.c"
			} else {
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 157 "../lib/DateTime.vala"
				if (with_weekday == FALSE) {
#line 157 "../lib/DateTime.vala"
					_tmp10_ = with_day == TRUE;
#line 752 "DateTime.c"
				} else {
#line 157 "../lib/DateTime.vala"
					_tmp10_ = FALSE;
#line 756 "DateTime.c"
				}
#line 157 "../lib/DateTime.vala"
				if (_tmp10_) {
#line 157 "../lib/DateTime.vala"
					_tmp9_ = with_year == FALSE;
#line 762 "DateTime.c"
				} else {
#line 157 "../lib/DateTime.vala"
					_tmp9_ = FALSE;
#line 766 "DateTime.c"
				}
#line 157 "../lib/DateTime.vala"
				if (_tmp9_) {
#line 770 "DateTime.c"
					gchar* _tmp11_;
#line 159 "../lib/DateTime.vala"
					_tmp11_ = g_strdup (_ ("%b %e"));
#line 159 "../lib/DateTime.vala"
					result = _tmp11_;
#line 159 "../lib/DateTime.vala"
					return result;
#line 778 "DateTime.c"
				} else {
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
#line 160 "../lib/DateTime.vala"
					if (with_weekday == TRUE) {
#line 160 "../lib/DateTime.vala"
						_tmp13_ = with_day == FALSE;
#line 786 "DateTime.c"
					} else {
#line 160 "../lib/DateTime.vala"
						_tmp13_ = FALSE;
#line 790 "DateTime.c"
					}
#line 160 "../lib/DateTime.vala"
					if (_tmp13_) {
#line 160 "../lib/DateTime.vala"
						_tmp12_ = with_year == TRUE;
#line 796 "DateTime.c"
					} else {
#line 160 "../lib/DateTime.vala"
						_tmp12_ = FALSE;
#line 800 "DateTime.c"
					}
#line 160 "../lib/DateTime.vala"
					if (_tmp12_) {
#line 804 "DateTime.c"
						gchar* _tmp14_;
#line 162 "../lib/DateTime.vala"
						_tmp14_ = g_strdup (_ ("%a %Y"));
#line 162 "../lib/DateTime.vala"
						result = _tmp14_;
#line 162 "../lib/DateTime.vala"
						return result;
#line 812 "DateTime.c"
					} else {
						gboolean _tmp15_ = FALSE;
						gboolean _tmp16_ = FALSE;
#line 163 "../lib/DateTime.vala"
						if (with_weekday == TRUE) {
#line 163 "../lib/DateTime.vala"
							_tmp16_ = with_day == FALSE;
#line 820 "DateTime.c"
						} else {
#line 163 "../lib/DateTime.vala"
							_tmp16_ = FALSE;
#line 824 "DateTime.c"
						}
#line 163 "../lib/DateTime.vala"
						if (_tmp16_) {
#line 163 "../lib/DateTime.vala"
							_tmp15_ = with_year == FALSE;
#line 830 "DateTime.c"
						} else {
#line 163 "../lib/DateTime.vala"
							_tmp15_ = FALSE;
#line 834 "DateTime.c"
						}
#line 163 "../lib/DateTime.vala"
						if (_tmp15_) {
#line 838 "DateTime.c"
							gchar* _tmp17_;
#line 165 "../lib/DateTime.vala"
							_tmp17_ = g_strdup (_ ("%a"));
#line 165 "../lib/DateTime.vala"
							result = _tmp17_;
#line 165 "../lib/DateTime.vala"
							return result;
#line 846 "DateTime.c"
						} else {
							gboolean _tmp18_ = FALSE;
							gboolean _tmp19_ = FALSE;
#line 166 "../lib/DateTime.vala"
							if (with_weekday == TRUE) {
#line 166 "../lib/DateTime.vala"
								_tmp19_ = with_day == TRUE;
#line 854 "DateTime.c"
							} else {
#line 166 "../lib/DateTime.vala"
								_tmp19_ = FALSE;
#line 858 "DateTime.c"
							}
#line 166 "../lib/DateTime.vala"
							if (_tmp19_) {
#line 166 "../lib/DateTime.vala"
								_tmp18_ = with_year == FALSE;
#line 864 "DateTime.c"
							} else {
#line 166 "../lib/DateTime.vala"
								_tmp18_ = FALSE;
#line 868 "DateTime.c"
							}
#line 166 "../lib/DateTime.vala"
							if (_tmp18_) {
#line 872 "DateTime.c"
								gchar* _tmp20_;
#line 168 "../lib/DateTime.vala"
								_tmp20_ = g_strdup (_ ("%a, %b %e"));
#line 168 "../lib/DateTime.vala"
								result = _tmp20_;
#line 168 "../lib/DateTime.vala"
								return result;
#line 880 "DateTime.c"
							} else {
								gboolean _tmp21_ = FALSE;
								gboolean _tmp22_ = FALSE;
#line 169 "../lib/DateTime.vala"
								if (with_weekday == FALSE) {
#line 169 "../lib/DateTime.vala"
									_tmp22_ = with_day == FALSE;
#line 888 "DateTime.c"
								} else {
#line 169 "../lib/DateTime.vala"
									_tmp22_ = FALSE;
#line 892 "DateTime.c"
								}
#line 169 "../lib/DateTime.vala"
								if (_tmp22_) {
#line 169 "../lib/DateTime.vala"
									_tmp21_ = with_year == FALSE;
#line 898 "DateTime.c"
								} else {
#line 169 "../lib/DateTime.vala"
									_tmp21_ = FALSE;
#line 902 "DateTime.c"
								}
#line 169 "../lib/DateTime.vala"
								if (_tmp21_) {
#line 906 "DateTime.c"
									gchar* _tmp23_;
#line 171 "../lib/DateTime.vala"
									_tmp23_ = g_strdup (_ ("%b"));
#line 171 "../lib/DateTime.vala"
									result = _tmp23_;
#line 171 "../lib/DateTime.vala"
									return result;
#line 914 "DateTime.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 174 "../lib/DateTime.vala"
	_tmp24_ = g_strdup ("");
#line 174 "../lib/DateTime.vala"
	result = _tmp24_;
#line 174 "../lib/DateTime.vala"
	return result;
#line 929 "DateTime.c"
}

/**
     * Converts seconds into the ISO 8601 standard date format for minutes (e.g. 100s to 01:40).
     * Output of negative seconds is prepended with minus character.
     *
     * @param seconds the number of seconds to convert into ISO 8601
     *
     * @return returns an ISO 8601 formatted string
     */
gchar*
granite_date_time_seconds_to_time (gint seconds)
{
	gint sign = 0;
	gint hours = 0;
	gint min = 0;
	gint sec = 0;
	gchar* result;
#line 186 "../lib/DateTime.vala"
	sign = 1;
#line 187 "../lib/DateTime.vala"
	if (seconds < 0) {
#line 188 "../lib/DateTime.vala"
		seconds = -seconds;
#line 189 "../lib/DateTime.vala"
		sign = -1;
#line 956 "DateTime.c"
	}
#line 192 "../lib/DateTime.vala"
	hours = seconds / 3600;
#line 193 "../lib/DateTime.vala"
	min = (seconds % 3600) / 60;
#line 194 "../lib/DateTime.vala"
	sec = seconds % 60;
#line 196 "../lib/DateTime.vala"
	if (hours > 0) {
#line 966 "DateTime.c"
		gchar* _tmp0_;
#line 197 "../lib/DateTime.vala"
		_tmp0_ = g_strdup_printf ("%d:%02d:%02d", sign * hours, min, sec);
#line 197 "../lib/DateTime.vala"
		result = _tmp0_;
#line 197 "../lib/DateTime.vala"
		return result;
#line 974 "DateTime.c"
	} else {
		gchar* _tmp1_;
#line 199 "../lib/DateTime.vala"
		_tmp1_ = g_strdup_printf ("%02d:%02d", sign * min, sec);
#line 199 "../lib/DateTime.vala"
		result = _tmp1_;
#line 199 "../lib/DateTime.vala"
		return result;
#line 983 "DateTime.c"
	}
}

